sailpoint.connector.webservices

## Class Endpoint

- java.lang.Object
- - sailpoint.connector.webservices.Endpoint

    public class Endpoint
    extends java.lang.Object

### Constructor Summary

Constructors
Constructor and Description
`Endpoint()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addHeader(java.lang.String entry, java.lang.String value)` Use this method to add a header value to the existing http header map for the request
`java.lang.String` `getAfterRule()` Use this method to get the name of the rule to run after the webservice request completes.
`java.lang.Object` `getAttribute(java.lang.String name)` Use this method to get the value of an attribute
`Attributes` `getAttributes()` Use this method to get all the available attributes
`java.lang.String` `getBaseUrl()` Use this method to get the base url (endpoint) of the operation that is to be performed for the particular operation
`java.lang.String` `getBeforeRule()` Use this method to get the name of the rule to run before the webservice request completes
`java.util.Map` `getBody()` Use this method to get the http payload information as a map.
`java.lang.String` `getContextUrl()` Use this method to get the context url for the particular operation (create user, update user, account aggregation, etc...)
`java.lang.String` `getFullUrl()` Use this method to get the complete url (endpoint) of the operation that is to be performed for the particular operation
`java.util.Map` `getHeader()` Use this method to get the header values for the request
`java.lang.String` `getHttpMethodType()` Use this method to get the http method type (put, post, get, patch, delete) for the particular operation (create user, update user, account aggregation, etc...)
`java.lang.String` `getOperationType()` Use this method to get the operation type (Account Aggregation, Group Aggregation, Create Account, etc...) for the particular operation record (create user, update user, account aggregation, etc...)
`java.util.Map` `getResMappingObj()` Use this method to get the response mapping for the response attributes returned from the JSON response of the managed source.
`java.util.List` `getResponseCode()` Use this method to get the value of successful response codes as a list (200,201,299).
`java.lang.String` `getRootPath()` Use this method to get the root of the JSON response returned from the managed source for the particular operation (create user, update user, account aggregation, etc...) Example root path for the json below: `$.results`
`int` `getSequenceNumberForEndpoint()` Use this method to get the sequence number for the particular operation (create user, update user, account aggregation, etc...)
`java.lang.String` `getUniqueNameForEndPoint()` Use this method to get the unique operation name for the particular operation (create user, update user, account aggregation, etc...)
`void` `setBaseUrl(java.lang.String value)` Use this method to set the base url (endpoint) of the operation that is to be performed for the particular operation
`void` `setBody(java.util.Map value)` Use this method to set the http payload information as a map.
`void` `setContextUrl(java.lang.String value)` Use this method to set the context url for the particular operation (create user, update user, account aggregation, etc...)
`void` `setFullUrl(java.lang.String value)` Use this method to set the complete url (endpoint) of the operation that is to be performed for the particular operation
`void` `setHeader(java.util.Map value)` Use this method to set the header values for the request
`void` `setHttpMethodType(java.lang.String value)` Use this method to set the http method type (put, post, get, patch, delete) for the particular operation (create user, update user, account aggregation, etc...)
`void` `setOperationType(java.lang.String value)` Use this method to set the operation type (Account Aggregation, Group Aggregation, Create Account, etc...) for the particular operation record (create user, update user, account aggregation, etc...)
`void` `setResMappingObj(java.util.Map value)` Use this method to set the response mapping for the response attributes returned from the JSON response of the managed source.
`void` `setResponseCode(java.util.List value)` Use this method to set the value of successful response codes as a list (200,201,299).
`void` `setRootPath(java.lang.String value)` Use this method to set the root of the JSON response returned from the managed source for the particular operation (create user, update user, account aggregation, etc...) Example root path for the json below: `$.results`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Endpoint

    public Endpoint()

### Method Detail

#### getAfterRule

    public java.lang.String getAfterRule()

Use this method to get the name of the rule to run after the webservice request completes.

#### getBeforeRule

    public java.lang.String getBeforeRule()

Use this method to get the name of the rule to run before the webservice request completes

#### setContextUrl

    public void setContextUrl(java.lang.String value)

Use this method to set the context url for the particular operation (create user, update user, account aggregation, etc...)

Parameters:
  `value` - the name of the context url

#### getContextUrl

    public java.lang.String getContextUrl()

Use this method to get the context url for the particular operation (create user, update user, account aggregation, etc...)

#### setHttpMethodType

    public void setHttpMethodType(java.lang.String value)

Use this method to set the http method type (put, post, get, patch, delete) for the particular operation (create user, update user, account aggregation, etc...)

Parameters:
  `value` - the name of the http method type [get, post, put, patch, delete]

#### getHttpMethodType

    public java.lang.String getHttpMethodType()

Use this method to get the http method type (put, post, get, patch, delete) for the particular operation (create user, update user, account aggregation, etc...)

#### setOperationType

    public void setOperationType(java.lang.String value)

Use this method to set the operation type (Account Aggregation, Group Aggregation, Create Account, etc...) for the particular operation record (create user, update user, account aggregation, etc...)

Parameters:
  `value` - the name of the operation type

#### getOperationType

    public java.lang.String getOperationType()

Use this method to get the operation type (Account Aggregation, Group Aggregation, Create Account, etc...) for the particular operation record (create user, update user, account aggregation, etc...)

#### setRootPath

    public void setRootPath(java.lang.String value)

Use this method to set the root of the JSON response returned from the managed source for the particular operation (create user, update user, account aggregation, etc...)
Example root path for the json below: `$.results`

         {
             "results": [
             {
                 "id": "12345",
                 "name": "John Doe"
                 "email": "john.doe@sailpoint.com"
             },
             {
                 "id": "54321",
                 "name": "Jane Doe",
                 "email": "jane.doe@sailpoint.com"
             }
             ]
         }

Parameters:
  `value` - the name of the root of the JSON response results

#### getRootPath

    public java.lang.String getRootPath()

Use this method to get the root of the JSON response returned from the managed source for the particular operation (create user, update user, account aggregation, etc...)
Example root path for the json below: `$.results`

         {
             "results": [
             {
                 "id": "12345",
                 "name": "John Doe"
                 "email": "john.doe@sailpoint.com"
             },
             {
                 "id": "54321",
                 "name": "Jane Doe",
                 "email": "jane.doe@sailpoint.com"
             }
             ]
         }

#### setFullUrl

    public void setFullUrl(java.lang.String value)

Use this method to set the complete url (endpoint) of the operation that is to be performed for the particular operation

       Example full url for Airtable Get Users call
       ex: https://api.airtable.com/v0/appe0bVnLjyV97hyg/Users

Parameters:
  `value` - the full url as a string

#### getFullUrl

    public java.lang.String getFullUrl()

Use this method to get the complete url (endpoint) of the operation that is to be performed for the particular operation

       Example full url for Airtable Get Users call
       ex: https://api.airtable.com/v0/appe0bVnLjyV97hyg/Users

#### setBaseUrl

    public void setBaseUrl(java.lang.String value)

Use this method to set the base url (endpoint) of the operation that is to be performed for the particular operation

         Example base url for Airtable Get Users call
         ex: https://api.airtable.com/v0/appe0bVnLjyV97hyg

Parameters:
  `value` - the base url as a string

#### getBaseUrl

    public java.lang.String getBaseUrl()

Use this method to get the base url (endpoint) of the operation that is to be performed for the particular operation

         Example base url for Airtable Get Users call
         ex: https://api.airtable.com/v0/appe0bVnLjyV97hyg

#### getSequenceNumberForEndpoint

    public int getSequenceNumberForEndpoint()

Use this method to get the sequence number for the particular operation (create user, update user, account aggregation, etc...)

#### getUniqueNameForEndPoint

    public java.lang.String getUniqueNameForEndPoint()

Use this method to get the unique operation name for the particular operation (create user, update user, account aggregation, etc...)

#### setResMappingObj

    public void setResMappingObj(java.util.Map value)

Use this method to set the response mapping for the response attributes returned from the JSON response of the managed source.
The key would be the attribute name from the source account schema and the value would be the JSON path after the root path.

         {
             "results": [
             {
              "fields": {
                 "id": "12345",
                 "name": "John Doe"
                 "email": "john.doe@sailpoint.com"
              }
             },
             {
              "fields": {
                 "id": "54321",
                 "name": "Jane Doe",
                 "email": "jane.doe@sailpoint.com"
              }
             }
             ]
         }

Root path: $.results
Response Map

         {
             "id": "fields.id",
             "name": "fields.name",
             "email": "fields.email"
         }

Parameters:
  `value` - the mapping of account schema attribute to the JSON path value in the JSON response

#### getResMappingObj

    public java.util.Map getResMappingObj()

Use this method to get the response mapping for the response attributes returned from the JSON response of the managed source.
The key would be the attribute name from the source account schema and the value would be the JSON path after the root path.

         {
             "results": [
             {
              "fields": {
                 "id": "12345",
                 "name": "John Doe"
                 "email": "john.doe@sailpoint.com"
              }
             },
             {
              "fields": {
                 "id": "54321",
                 "name": "Jane Doe",
                 "email": "jane.doe@sailpoint.com"
              }
             }
             ]
         }

Root path: $.results
Response Map

         {
             "id": "fields.id",
             "name": "fields.name",
             "email": "fields.email"
         }

#### setHeader

    public void setHeader(java.util.Map value)

Use this method to set the header values for the request

         //Set Header Content-Type
         Map headerMap = requestEndPoint.getHeader();
         headerMap.put("Content-Type", "application/json");
         requestEndPoint.setHeader(headerMap);

Parameters:
  `value` - the map of http headers to send with the request

#### getHeader

    public java.util.Map getHeader()

Use this method to get the header values for the request

         //Set Header Content-Type
         Map headerMap = requestEndPoint.getHeader();
         headerMap.put("Content-Type", "application/json");
         requestEndPoint.setHeader(headerMap);

#### addHeader

    public void addHeader(java.lang.String entry,
                          java.lang.String value)

Use this method to add a header value to the existing http header map for the request

         requestEndPoint.addHeader("Authorization", "Bearer " + accessToken);

Parameters:
  `entry` - the key for the header
  `value` - the value for the header

#### setBody

    public void setBody(java.util.Map value)

Use this method to set the http payload information as a map.
The map must contain three keys `bodyFormat, bodyFormData, jsonBody`. The bodyFormat value can be `raw`
which means the user has provided values as a raw JSON string, otherwise the user has provided the value in the key,value format that must be converted into JSON

Parameters:
  `value` - the http payload map

#### getBody

    public java.util.Map getBody()

Use this method to get the http payload information as a map.
The map contains three keys `bodyFormat, bodyFormData, jsonBody`.

#### setResponseCode

    public void setResponseCode(java.util.List value)

Use this method to set the value of successful response codes as a list (200,201,299). This will be respected by the connector.
If any other response codes are returned this would be considered as a request failure.

Parameters:
  `value` - the list of successful response code values

#### getResponseCode

    public java.util.List getResponseCode()

Use this method to get the value of successful response codes as a list (200,201,299).

#### getAttributes

    public Attributes getAttributes()

Use this method to get all the available attributes

Returns:

#### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)

Use this method to get the value of an attribute

Parameters:
  `name` - the name of the attribute
Returns: